#ifndef INCLUDE_INPUT_PREFERENCE_H
#define INCLUDE_INPUT_PREFERENCE_H

#include "papaya/Preference.h"
#include "PreferenceHandler.h"
#include "papaya/ColourEditor.h"

class InputPreference : public Preference {
 public:
  InputPreference();
  ~InputPreference();

  GtkWidget * getWidget();
  void destroyWidget();

  Category * getCategories();

  // Not really public, but C function needs access.
  void setTerminatorEntryState(bool);

  void loadPreferences(Prefs *);
  void applyPreferences(Prefs *);

 private:
  ColourEditor * echo_editor;

};

const Category input_categories[] = {
  CategoryTerminalInput,
  CategoryTerminal,
  CategoryLast
};


#endif // INCLUDE_INPUT_PREFERENCE_H
