#ifndef INCLUDE_PLUGINDATA_H
#define INCLUDE_PLUGINDATA_H

class PluginData {

 public:

  PluginData(char *);
  ~PluginData();

  int load();

  bool enabled();
  void enable(bool);
  bool seen;

  void setName(char *);
  void setFilename(char *);
  void setDescription(char *);
  void setMajor(char *);
  void setMinor(char *);

  char * getName();
  char * getFilename();
  char * getDescription();
  int getMajor();
  int getMinor();

  GtkWidget * dialog;

  void toString();

 private:

  char * author;
  char * authorEmail;
  char * name;
  char * filename;

  char * downloadURL;
  char * checksum;
  char * version;
  char * description;

  int major;
  int minor;

  


  FILE * infoFile;  // PluginName.inf
  bool en; // Is this plugin enabled?

  void set(char *, char *);
};

#endif
