#include "papaya/Plugin.h"
#include <Python.h>
#include <list>

class G_MODULE_EXPORT PythonPlugin : public Plugin {

 public:

  PythonPlugin();
  ~PythonPlugin();

  //  void init(int, char **);
  //  void quit(void *);
  //   bool run(char *);
  char * getDescription();

  void input(Connection *, char *);
  void output(Connection *, char *);
  void prompt(Connection *, char *);
  void onEvent(Event *, Connection *);
  void clientMessage(Connection *, char *);

  void set(const char *, int);
  void set(const char *, long);
  void set(const char *, const char *);
  int getInt(const char *);
  long getLong(const char *);
  char * getString(const char *);

  PyObject * getFunction(const char *);
  PyObject * codeCompile(const char *);

  bool runFunction(const char *, const char *, char *);
  bool runFunction(const char *, const char *, const char *, char *);
  bool loadFile(const char *, bool);
  char * findFile(const char *, const char *);

 private:
  PyObject * module;
  PyObject * globals;

  PyObject * regexp_fixer;

  
};

